bookstore/urls.py
from django.contrib import admin
from django.conf.urls.static import static
from django.urls import include, path

from bookstore import settings

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('shop.urls')),
    path('', include('orders.urls')),
    path('users/', include('users.urls')),
    path('users/', include('django.contrib.auth.urls')),

]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

shop/urls.py
from django.urls import path
from django.views.generic import TemplateView

from .views import Home, ProductDetailView, about_us_view, contact, product_list_view

app_name = 'shop'


urlpatterns = [
    path('', Home.as_view(), name='home'),
    path('category/<str:category_slug>/', product_list_view, name='product_list'),
    path('product/<str:slug>/', ProductDetailView.as_view(), name='product_detail'),
    path('testimonials/', TemplateView.as_view(template_name='shop/testimonials.html'), name='testimonials'),
    path('contact-us/', contact, name='contact_us'),
    path('about/', about_us_view, name='about'),
    path('terms/', TemplateView.as_view(template_name='shop/terms.html'), name='terms'),

]

users/urls.py
from django.contrib.auth.views import PasswordChangeView
from django.urls import path

from .views import (
    ProfileView,
    UsersLoginView,
    ProfileUpdateView,
    UsersLogoutView,
    SignUpView,
    UserPasswordChangeView,
    UserEmailChangeView,
    UserPasswordResetConfirmView,
    UserPasswordResetDoneView,
    UserPasswordResetFormView,
    UserResetPasswordComplete,
)

app_name = 'users'

urlpatterns = [
    path('signup/', SignUpView.as_view(), name='signup'),
    path('login/', UsersLoginView.as_view(), name='login'),
    path('login/<int:error_id>', UsersLoginView.as_view(), name='login-advance'),
    path('logout/', UsersLogoutView.as_view(), name='logout'),
    path('change-password', UserPasswordChangeView.as_view(), name='change_password'),
    path('change-email', UserEmailChangeView.as_view(), name='change_email'),
    path('profile/', ProfileView.as_view(), name='profile'),
    path('profile-update/', ProfileUpdateView.as_view(), name='profile_update'),
    path('password-reset/', UserPasswordResetFormView.as_view(), name='password_reset'),
    path('password-reset/done/', UserPasswordResetDoneView.as_view(), name='password_reset_done'),
    path('password-reset/complete/', UserResetPasswordComplete.as_view(), name='password_reset_complete'),
    path('reset/<uidb64>/<token>/', UserPasswordResetConfirmView.as_view(), name='password_reset_confirm'),

]

users/models.py
"""Declare models for YOUR_APP app."""

from django.db import models
from django.contrib.auth.models import AbstractUser
from django.utils import timezone
from django.utils.html import format_html
from django.utils.translation import ugettext_lazy as _
from sorl.thumbnail import get_thumbnail

from .managers import UserManager


class UserRegistration(AbstractUser):
    username = None
    email = models.EmailField(_('email address'), unique=True)

    phone_no = models.CharField(max_length=13)
    country = models.CharField(max_length=35, default='Romania')
    county = models.CharField(max_length=35)
    city = models.CharField(max_length=35)
    address = models.CharField(max_length=225)
    street = models.CharField(max_length=105)
    zip_code = models.IntegerField(default=000000)
    thumbnail = models.ImageField(upload_to='user/thumbnail/%Y/%m/%d/',
                                  blank=True, default='no_profile_img.png', help_text='Optional')
    email_communication = models.BooleanField(default=False)
    mail_communication = models.BooleanField(default=False)
    phone_communication = models.BooleanField(default=False)

    USERNAME_FIELD = 'email'
    REQUIRED_FIELDS = ['first_name', 'last_name']

    @property
    def thumbnail_preview(self):
        if self.thumbnail:
            _thumbnail = get_thumbnail(self.thumbnail,
                                       '150x150',
                                       upscale=False,
                                       crop=False,
                                       quality=100)
            return format_html(
                '<img src="{}" width="{}" height="{}">'.format(_thumbnail.url, _thumbnail.width, _thumbnail.height))
        return ""

    @property
    def avatarURL(self):
        try:
            url = self.thumbnail.url
        except:
            url = ''
        return url

    objects = UserManager()

    def __str__(self):
        return "{}".format(self.email)


class RejectedUserAccountRequest(models.Model):
    email = models.EmailField(_('email address'))
    rejected_date = models.DateTimeField(default=timezone.now)

    def __str__(self):
        return self.email


class RequestMade(models.Model):
    ip = models.CharField(max_length=65)
    date_time = models.DateTimeField(default=timezone.now)

    def __str__(self):
        return self.ip

users/forms.py
from django import forms

from django.utils.translation import ugettext_lazy as _
from django.contrib.auth.forms import PasswordResetForm, UserCreationForm

from .models import UserRegistration

county = (
    ("0", "Județul de expediție",),
    ("Alba", "Alba",),
    ("Arad", "Arad",),
    ("Arges", "Argeș",),
    ("Bacau", "Bacău",),
    ("Bihor", "Bihor",),
    ("Bistrita-Nasaud", "Bistrița-Năsăud",),
    ("Botosani", "Botoșani",),
    ("Braila", "Brăila",),
    ("Brasov", "Brașov",),
    ("Bucuresti", "București",),
    ("Buzau", "Buzău",),
    ("Calarasi", "Călărași",),
    ("Caras-Severin", "Caraș-Severin",),
    ("Cluj", "Cluj",),
    ("Constanta", "Constanța",),
    ("Covasna", "Covasna",),
    ("Dambovita", "Dâmbovița",),
    ("Dolj", "Dolj",),
    ("Galati", "Galați",),
    ("Giurgiu", "Giurgiu",),
    ("Gorj", "Gorj",),
    ("Harghita", "Harghita",),
    ("Hunedoara", "Hunedoara",),
    ("Ialomita", "Ialomița",),
    ("Iasi", "Iași",),
    ("Ilfov", "Ilfov",),
    ("Maramures", "Maramureș",),
    ("Mehedinti", "Mehedinți",),
    ("Mures", "Mureș",),
    ("Neamt", "Neamț",),
    ("Olt", "Olt",),
    ("Prahova", "Prahova",),
    ("Salaj", "Sălaj",),
    ("Satu Mare", "Satu Mare",),
    ("Sibiu", "Sibiu",),
    ("Suceava", "Suceava",),
    ("Teleorman", "Teleorman",),
    ("Timis", "Timiș",),
    ("Tulcea", "Tulcea",),
    ("Valcea", "Vâlcea",),
    ("Vaslui", "Vaslui",),
    ("Vrancea", "Vrancea",),
)
country = (
    ("Romania", "Romania",),
)


class UserSignupForm(UserCreationForm):
    first_name = forms.CharField(required=True)
    last_name = forms.CharField(required=True)
    email_confirmation = forms.EmailField()
    country = forms.ChoiceField(choices=country)
    county = forms.ChoiceField(choices=county)
    email_communication = forms.BooleanField(required=False)
    mail_communication = forms.BooleanField(required=False)
    phone_communication = forms.BooleanField(required=False)

    class Meta(UserCreationForm):
        model = UserRegistration
        fields = (
            'first_name',
            'last_name',
            'email',
            'email_confirmation',
            'phone_no',
            'country',
            'county',
            'city',
            'street',
            'zip_code',
            'thumbnail',
            'email_communication',
            'mail_communication',
            'phone_communication',
            'password1',
            'password2'
        )

    def clean(self):
        cleaned_data = super(UserSignupForm, self).clean()
        email = cleaned_data.get('email')
        email_confirmation = cleaned_data.get('email_confirmation')

        if email and email_confirmation and email != email_confirmation:
            self._errors['email_confirmation'] = self.error_class(['Emails do not match.'])
            del self.cleaned_data['email_confirmation']
        return cleaned_data


class UserUpdateForm(forms.ModelForm):
    first_name = forms.CharField(label='First Name', required=True)
    last_name = forms.CharField(label='Last Name', required=True)
    email_communication = forms.BooleanField(required=False)
    mail_communication = forms.BooleanField(required=False)
    phone_communication = forms.BooleanField(required=False)

    class Meta:
        model = UserRegistration
        fields = (
            'first_name',
            'last_name',
            'phone_no',
            'email',
            'country',
            'county',
            'city',
            'street',
            'zip_code',
            'thumbnail',
            'email_communication',
            'mail_communication',
            'phone_communication'
        )


class EmailChangeForm(forms.ModelForm):
    email_confirmation = forms.EmailField()

    class Meta:
        model = UserRegistration
        fields = (
            'email',
            'email_confirmation'
        )

    def clean(self):
        cleaned_data = super(EmailChangeForm, self).clean()
        email = cleaned_data.get('email')
        email_confirmation = cleaned_data.get('email_confirmation')

        if email and email_confirmation and email != email_confirmation:
            self._errors['email_confirmation'] = self.error_class(['Emails do not match.'])
            del self.cleaned_data['email_confirmation']
        return cleaned_data


class EmailValidationOnForgotPassword(PasswordResetForm):

    def clean_email(self):
        email = self.cleaned_data['email']
        if not UserRegistration.objects.filter(email__iexact=email, is_active=True).exists():
            msg = _("There is no user registered with the specified E-Mail address.")
            self.add_error('email', msg)
        return email

users/views.py
import datetime

from django.contrib.auth.mixins import LoginRequiredMixin
from django.contrib.auth.views import *

from django.urls import reverse_lazy
from django.utils import timezone

from django.views.generic import CreateView, TemplateView, UpdateView

from .forms import EmailChangeForm, EmailValidationOnForgotPassword, UserSignupForm, UserUpdateForm
from .models import UserRegistration, RequestMade


class ProfileView(LoginRequiredMixin, TemplateView):
    template_name = 'user/profile/profile_view.html'


class ProfileUpdateView(UpdateView, LoginRequiredMixin):
    model = UserRegistration
    form_class = UserUpdateForm
    template_name = 'user/profile/profile_update.html'
    success_url = reverse_lazy('users:profile')

    def get_object(self, queryset=None):
        return self.request.user


class UserEmailChangeView(UpdateView, LoginRequiredMixin):
    model = UserRegistration
    form_class = EmailChangeForm
    template_name = 'user/profile/change_email.html'
    success_url = reverse_lazy('users:profile')

    def get_object(self, queryset=None):
        return self.request.user


class SignUpView(CreateView):
    form_class = UserSignupForm
    success_url = reverse_lazy('users:login')
    template_name = 'user/profile/signup.html'


def get_client_ip(request):
    remote_address = request.META.get('HTTP_X_FORWARDED_FOR') or request.META.get('REMOTE_ADDR')
    ip = remote_address

    return ip


class UsersLoginView(LoginView):
    template_name = 'user/login.html'

    def post(self, request, *args, **kwargs):

        # cap_url = 'https://www.google.com/recaptcha/api.js'
        #
        # captcha_token = request.POST.get('g-recaptcha-response')
        # cap_secret = '6LddvEMaAAAAABQ95vLQDDcseXHObAK_WMOavBmt'  # V 3
        # cap_data = {
        #     'secret': cap_secret,
        #     'response': captcha_token
        # }
        # cap_server_response = request.post(url=cap_url, data=cap_data)
        # response_dict: dict = json.loads(cap_server_response.content)
        # print('RECAPTCHA:', response_dict)
        # if response_dict.get('success', False) and response_dict.get('score') > 0.5:
        #     return super().post(request, *args, **kwargs)
        # else:
        #     return self.render_to_response(self.get_context_data(error_id=1))

        ip = get_client_ip(request)
        request_made = RequestMade.objects.create(ip=ip)
        request_made.save()
        one_min_ago = timezone.now() - datetime.timedelta(minutes=1)
        previous_request = RequestMade.objects.filter(ip=ip, date_time__gt=one_min_ago).count()

        if previous_request > 3:
            return self.render_to_response(self.get_context_data(error_id=1))
        else:
            return super().post(request, *args, **kwargs)


class UsersLogoutView(LogoutView):
    template_name = 'user/logout.html'


class UserPasswordChangeView(PasswordChangeView, LoginRequiredMixin):
    template_name = 'user/password/change_password.html'
    success_url = '/'


class UserPasswordResetFormView(PasswordResetView):
    form_class = EmailValidationOnForgotPassword
    template_name = 'user/password/password_reset_form.html'
    success_url = reverse_lazy('users:password_reset_done')


class UserPasswordResetDoneView(PasswordResetDoneView):
    template_name = 'user/password/password_reset_done.html'


class UserPasswordResetConfirmView(PasswordResetConfirmView):
    success_url = reverse_lazy('users:password_reset_complete')
    template_name = 'user/password/password_reset_confirm.html'


class UserResetPasswordComplete(PasswordResetCompleteView):
    template_name = 'user/password/password_reset_complete.html'

templates/user/password/change_password.html
{% extends "base.html" %}
{% load crispy_forms_filters %}
{% load crispy_forms_tags %}

{% block main %}
    <div id="wrapper">
        <div class="inner">
            <form method="POST">
                {% csrf_token %}
                <fieldset class="form-group">
                    <legend class="border-bottom mb-4"></legend>
                    {{ form | crispy }}
                </fieldset>
                <div class="form-grup">
                    <br>
                    <button class="btn btn-outline-info" type="submit">Change Password</button>
                    <small class="text-muted ml-2">
                        <a href="{% url 'users:password_reset' %}">Forget password?</a>
                    </small>
                </div>
            </form>
        </div>
    </div>
{% endblock %}

templates/user/password/password_reset_complete.html
{% extends 'base.html' %}

{% block main %}
    <div id="wrapper">
        <div class="inner">
            <h1 align="center">The password has been changed!</h1>
{#            <p><a href="{% url 'users:login' %}">Log in.</a></p>#}
        </div>
    </div>
{% endblock %}

templates/user/password/password_reset_confirm.html
{% extends 'base.html' %}

{% block main %}
    <div id="wrapper">
        <div class="inner">
            {% if validlink %}
                <p>Please enter new password.</p>
                <form action="" method="post">
                    {% csrf_token %}
                    <table>
                        <tr>
                            <td>{{ form.new_password1.errors }}
                                <label for="id_new_password1">New password:</label></td>
                            <td>{{ form.new_password1 }}</td>
                        </tr>
                        <tr>
                            <td>{{ form.new_password2.errors }}
                                <label for="id_new_password2">Confirm password:</label></td>
                            <td>{{ form.new_password2 }}</td>
                        </tr>
                        <tr>
                            <td></td>
                            <td><input type="submit" value="Change my password"/></td>
                        </tr>
                    </table>
                </form>
            {% else %}
                <h1>Password reset failed</h1>
                <p>The password reset link was invalid or already used. Please request a new password reset.</p>
            {% endif %}
        </div>
    </div>
{% endblock %}

templates/user/password/password_reset_done.html
{% extends 'base.html' %}

{% block main %}
    <div id="wrapper">
        <div class="inner">
            <p>An email with password reset instructions has been sent to your address...</p>
        </div>
    </div>
{% endblock %}

templates/user/password/password_reset_email.html
Someone asked for password reset for email {{ email }}. Follow the link below:
{{ protocol }}://{{ domain }}{% url 'users:password_reset_confirm' uidb64=uid token=token %}

templates/user/password/password_reset_form.html
{% extends 'base.html' %}
{% load crispy_forms_filters %}
{% load crispy_forms_tags %}

{% block main %}
    <div id="wrapper">
        <div class="inner">
            <form action="" method="post">
                {% csrf_token %}
                {% if form.email.errors %}
                    {{ form.email.errors }}
                {% endif %}
                <label for="email">{{ form.email | as_crispy_field}}</label>
                <input type="submit" class="btn btn-default btn-lg" value="Reset password">
            </form>
        </div>
    </div>
{% endblock %}